var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F01285;
(function (F01285) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetObasData());
            result.push(this.GetUsdData());
            result.push(this.GetNpaData());
            result.push({ Id: "Курс", Data: null });
            result.push({ Id: "Изменение_БА", Data: null });
            result.push({ Id: "ОБАС1", Data: null });
            return result;
        };
        ExportRules.prototype.GetObasData = function () {
            var srcTable = this._document.P2UniqOrgsTable;
            var orgNameId = srcTable.Org.NameFieldId;
            var template = "<a ID=\"{{order}}\" b1=\"{{CountryCode}}\" b1_clone=\"{{CountryCode}}\" b2=\"{{" + orgNameId + "}}\" bFILTERINGCOLUMN=\"{{FilterKey}}\" />";
            var modifier = function (record) {
                record["CountryCode"] = srcTable.Country.Code;
                record["FilterKey"] = srcTable.CalcFilterKey();
                return record;
            };
            return this.CreateTableInfo(srcTable, [orgNameId], template, "\u0420\u0410\u0421\u0427\u0415\u0422_\u0412\u041E\u0415\u041D\u041D\u041E\u0421\u041B\u0423\u0416\u0410\u0429\u0418\u0415", modifier);
        };
        ExportRules.prototype.GetUsdData = function () {
            var srcTable = this._document.P2DataTransTable;
            var template = "<a ID=\"{{order}}\" b3=\"{{PostName}}\"";
            var fields = [];
            for (var i = 0; i < 5; i++) {
                var fieldId = "g" + (5 + i);
                fields.push(fieldId);
                template += " b" + (4 + i) + "=\"{{" + fieldId + "}}\"";
            }
            this._document.IterateByYears(function (j) {
                var fieldId = "g4" + j;
                fields.push(fieldId);
                template += " b" + (9 + j) + "=\"{{" + fieldId + "}}\"";
            }, false);
            template += " bFILTERINGCOLUMN=\"{{FilterKey}}\" bcheckbox=\"true\" bcheckbox1=\"true\" />";
            var sprTable = this._document.PostSprTable;
            var modifier = function (record) {
                record["PostName"] = sprTable.Name.LookupByKeys(srcTable.GetFieldValue("PostName_ID"));
                record["FilterKey"] = srcTable.GetFieldValue("OKSM_ID") + "_" + srcTable.GetFieldValue("Organization_ID");
                return record;
            };
            return this.CreateTableInfo(srcTable, fields, template, "РасчетСША", modifier);
        };
        ExportRules.prototype.GetNpaData = function () {
            var srcTable = this._document.NpaTable;
            var template = new BxmlExportTemplate();
            template.InsertDynField("1", "PartSalaryName");
            template.InsertDynField("7", "NpaCode");
            template.InsertField("8", srcTable.NpaDate, BxmlExportHelper.RegisteredHelpers.DateToStr);
            template.InsertField("9", srcTable.NpaNumber);
            template.InsertField("npacolumn", srcTable.NpaName);
            template.InsertDynField("10", "NpaStatusCode");
            template.InsertField("11", srcTable.NpaStatusChangeDate, BxmlExportHelper.RegisteredHelpers.DateToStr);
            var modifier = function (record) {
                record["PartSalaryName"] = srcTable.Salary.Name;
                record["NpaCode"] = srcTable.NpaType.Code;
                record["NpaStatusCode"] = srcTable.NpaStatus.Code;
                return record;
            };
            return this.CreateTableInfo(srcTable, template.FieldIds, template.Template, "НПА", modifier);
        };
        ExportRules.prototype.GetChangeData = function () {
            var srcTable = this._document.P3DataTable;
            var template = "<a ID=\"{{order}}\"";
            var usdField = BaseObasTableFields.UsdYearDataField;
            var fields = ["Y1"];
            this._document.IterateByYears(function (i) {
                var fieldId = usdField.GenerateId(i);
                fields.push(fieldId);
                template += " b" + (2 + i) + "=\"{{" + fieldId + "}}\"";
            });
            template += " b7=\"{{Y1}}\" bcheckbox=\"true\" bcheckbox1=\"true\" bFILTERINGCOLUMN=\"{{FilterKey}}\" />";
            var modifier = function (record) {
                record["FilterKey"] = srcTable.OwnerKey.SourceTable.CalcFilterKey();
                return record;
            };
            return this.CreateTableInfo(srcTable, fields, template, "Изменение_БА", modifier);
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F01285.ExportRules = ExportRules;
})(F01285 || (F01285 = {}));
