﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F01500;
(function (F01500) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP2Data("\u0420\u0430\u0441\u0447\u0435\u0442"));
            result.push(this.GetNpaData("\u041D\u041F\u0410"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            result.push(this.GetObasData("\u041E\u0411\u0410\u0421"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
result.push(this.GetAnalyticKosguRemainsData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423_\u041E\u0441\u0442\u0430\u0442\u043E\u043A", kosguData));
            return result;
        };
        ExportRules.prototype.GetP2Data = function (barsTableId) {
            var dataTable = this._document.TableP2Data;
            var srcTable = this._document.TransTableP2Data;
            var GenYearData = function (fieldId, startIndex) {
                var result = "";
                for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                    result += "b" + (startIndex + j) + "=\"" + (srcTable.GetFieldValue(fieldId + j.toString()) || 0) + "\" ";
                }
                return result;
            };
            var srcData = [];
            var i = 0;
            var payFieldId = dataTable.Payment.ForeignKey.Id;
            var payTable = ObasTableCollection.PaymentReestrSprTable;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                var payCode = "";
                if (payTable.Locate(payTable.RecordKey.Id, srcTable.GetFieldValue(payFieldId))) {
                    payCode = payTable.Code.Value;
                }
                template += "b1=\"" + (payCode || "") + "\" ";
                template += GenYearData(dataTable.PayValue.Id, 3);
                template += "b6=\"" + (srcTable.GetFieldValue(dataTable.PayCount.Id + "0") || 0) + "\" ";
                template += GenYearData(dataTable.PayCount.Id, 7);
                template += GenYearData(dataTable.ObasSum.Id, 11);
                template += "b1_clone=\"" + (payCode || "") + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetNpaData = function (barsTableId) {
            var srcTable = this._document.TableP3;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (srcTable.GetFieldValue("PaymentName") || "") + "\" ";
                template += "b6=\"False\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b7=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b8=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b9=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "bstate=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                template += "bDateChanState=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetObasData = function (barsTableId) {
            var tableP1 = this._document.TableP1Values;
            var totalTable = this._document.TableP1TopValues;
            var srcData = [];
            var template = "<a ID=\"01\" ";
            for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                template += "b" + (3 + j) + "=\"" + (totalTable.GetFieldValue("Y" + (j + 1).toString()) || 0) + "\" ";
            }
            template += "/>";
            srcData.push(template);
            template = "<a ID=\"02\" b3=\"0\" b4=\"0\" b5=\"0\" />";
            srcData.push(template);
            tableP1.Locate(tableP1.RecordKey.Id, 100);
            template = "<a ID=\"100\" ";
            for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                template += "b" + (3 + j) + "=\"" + (tableP1.GetFieldValue("Y" + (j + 1).toString()) || 0) + "\" ";
            }
            template += "/>";
            srcData.push(template);
            for (var i = 1; i <= ObasStageSettings.YearsCount + 1; i++) {
                srcData.push("<c ID=\"SUM_" + i + "\" />");
            }
            return { Id: barsTableId, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F01500.ExportRules = ExportRules;
})(F01500 || (F01500 = {}));
